diff -uNrp a/panels/region/cinnamon-region-panel.ui b/panels/region/cinnamon-region-panel.ui
--- a/panels/region/cinnamon-region-panel.ui	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cinnamon-region-panel.ui	2013-09-21 13:24:15.347949247 +0100
@@ -772,168 +862,111 @@
                           </packing>
                         </child>
                         <child>
-                          <object class="GtkVBox" id="vbox33">
+                          <object class="GtkFrame" id="frame4">
                             <property name="visible">True</property>
                             <property name="can_focus">False</property>
-                            <property name="spacing">12</property>
+                            <property name="label_xalign">0</property>
+                            <property name="shadow_type">none</property>
                             <child>
-                              <object class="GtkVBox" id="vbox34">
+                              <object class="GtkAlignment" id="alignment3">
                                 <property name="visible">True</property>
                                 <property name="can_focus">False</property>
-                                <property name="spacing">6</property>
+                                <property name="left_padding">12</property>
                                 <child>
-                                  <object class="GtkRadioButton" id="chk_same_group">
-                                    <property name="label" translatable="yes">Use the same layout for all windows</property>
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">True</property>
-                                    <property name="receives_default">False</property>
-                                    <property name="xalign">0</property>
-                                    <property name="active">True</property>
-                                    <property name="draw_indicator">True</property>
-                                  </object>
-                                  <packing>
-                                    <property name="expand">True</property>
-                                    <property name="fill">True</property>
-                                    <property name="position">0</property>
-                                  </packing>
-                                </child>
-                                <child>
-                                  <object class="GtkRadioButton" id="chk_separate_group_per_window">
-                                    <property name="label" translatable="yes">Allow different layouts for individual windows</property>
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">True</property>
-                                    <property name="receives_default">False</property>
-                                    <property name="xalign">0</property>
-                                    <property name="active">True</property>
-                                    <property name="draw_indicator">True</property>
-                                    <property name="group">chk_same_group</property>
-                                  </object>
-                                  <packing>
-                                    <property name="expand">True</property>
-                                    <property name="fill">True</property>
-                                    <property name="position">1</property>
-                                  </packing>
-                                </child>
-                                <child>
-                                  <object class="GtkAlignment" id="alignment1">
+                                  <object class="GtkGrid" id="shortcuts-grid">
                                     <property name="visible">True</property>
                                     <property name="can_focus">False</property>
-                                    <property name="left_padding">12</property>
+                                    <property name="margin_top">6</property>
+                                    <property name="row_spacing">6</property>
+                                    <property name="column_spacing">6</property>
                                     <child>
-                                      <object class="GtkVBox" id="vbox4">
+                                      <object class="GtkLabel" id="prev-source-label">
                                         <property name="visible">True</property>
                                         <property name="can_focus">False</property>
-                                        <child>
-                                          <object class="GtkRadioButton" id="chk_new_windows_default_layout">
-                                            <property name="label" translatable="yes">New windows use the default layout</property>
-                                            <property name="visible">True</property>
-                                            <property name="can_focus">True</property>
-                                            <property name="receives_default">False</property>
-                                            <property name="xalign">0</property>
-                                            <property name="active">True</property>
-                                            <property name="draw_indicator">True</property>
-                                          </object>
-                                          <packing>
-                                            <property name="expand">True</property>
-                                            <property name="fill">True</property>
-                                            <property name="position">0</property>
-                                          </packing>
-                                        </child>
-                                        <child>
-                                          <object class="GtkRadioButton" id="chk_new_windows_inherit_layout">
-                                            <property name="label" translatable="yes">New windows use the previous window's layout</property>
-                                            <property name="visible">True</property>
-                                            <property name="can_focus">True</property>
-                                            <property name="receives_default">False</property>
-                                            <property name="xalign">0</property>
-                                            <property name="active">True</property>
-                                            <property name="draw_indicator">True</property>
-                                            <property name="group">chk_new_windows_default_layout</property>
-                                          </object>
-                                          <packing>
-                                            <property name="expand">True</property>
-                                            <property name="fill">True</property>
-                                            <property name="position">1</property>
-                                          </packing>
-                                        </child>
+                                        <property name="xalign">0</property>
+                                        <property name="label" translatable="yes">Switch to previous source</property>
                                       </object>
+                                      <packing>
+                                        <property name="left_attach">0</property>
+                                        <property name="top_attach">0</property>
+                                        <property name="width">1</property>
+                                        <property name="height">1</property>
+                                      </packing>
+                                    </child>
+                                    <child>
+                                      <object class="GtkLabel" id="prev-source-shortcut-label">
+                                        <property name="visible">True</property>
+                                        <property name="can_focus">False</property>
+                                        <property name="halign">end</property>
+                                        <property name="hexpand">True</property>
+                                        <property name="label" translatable="yes">Ctrl+Alt+Space</property>
+                                        <style><class name="dim-label"/></style>
+                                      </object>
+                                      <packing>
+                                        <property name="left_attach">1</property>
+                                        <property name="top_attach">0</property>
+                                        <property name="width">1</property>
+                                        <property name="height">1</property>
+                                      </packing>
+                                    </child>
+                                    <child>
+                                      <object class="GtkLabel" id="next-source-label">
+                                        <property name="visible">True</property>
+                                        <property name="can_focus">False</property>
+                                        <property name="xalign">0</property>
+                                        <property name="label" translatable="yes">Switch to next source</property>
+                                      </object>
+                                      <packing>
+                                        <property name="left_attach">0</property>
+                                        <property name="top_attach">1</property>
+                                        <property name="width">1</property>
+                                        <property name="height">1</property>
+                                      </packing>
+                                    </child>
+                                    <child>
+                                      <object class="GtkLabel" id="next-source-shortcut-label">
+                                        <property name="visible">True</property>
+                                        <property name="can_focus">False</property>
+                                        <property name="halign">end</property>
+                                        <property name="hexpand">True</property>
+                                        <property name="label" translatable="yes">Ctrl+Alt+Shift+Space</property>
+                                        <style><class name="dim-label"/></style>
+                                      </object>
+                                      <packing>
+                                        <property name="left_attach">1</property>
+                                        <property name="top_attach">1</property>
+                                        <property name="width">1</property>
+                                        <property name="height">1</property>
+                                      </packing>
+                                    </child>
+                                    <child>
+                                      <object class="GtkLinkButton" id="jump-to-shortcuts">
+                                        <property name="visible">True</property>
+                                        <property name="can_focus">True</property>
+                                        <property name="label" translatable="yes">Shortcut Settings</property>
+                                        <property name="halign">end</property>
+                                      </object>
+                                      <packing>
+                                        <property name="left_attach">1</property>
+                                        <property name="top_attach">2</property>
+                                        <property name="width">1</property>
+                                        <property name="height">1</property>
+                                      </packing>
                                     </child>
                                   </object>
-                                  <packing>
-                                    <property name="expand">True</property>
-                                    <property name="fill">True</property>
-                                    <property name="position">2</property>
-                                  </packing>
                                 </child>
                               </object>
-                              <packing>
-                                <property name="expand">False</property>
-                                <property name="fill">False</property>
-                                <property name="position">0</property>
-                              </packing>
-                            </child>
-                            <child>
-                              <object class="GtkLabel" id="label2">
-                                <property name="visible">True</property>
-                                <property name="can_focus">False</property>
-                              </object>
-                              <packing>
-                                <property name="expand">True</property>
-                                <property name="fill">False</property>
-                                <property name="position">1</property>
-                              </packing>
                             </child>
-                            <child>
-                              <object class="GtkHButtonBox" id="hbuttonbox2">
+                            <child type="label">
+                              <object class="GtkLabel" id="shortcuts-frame-label">
                                 <property name="visible">True</property>
                                 <property name="can_focus">False</property>
-                                <property name="spacing">6</property>
-                                <property name="layout_style">end</property>
-                                <child>
-                                  <object class="GtkButton" id="xkb_layout_options">
-                                    <property name="label" translatable="yes">_Options...</property>
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">True</property>
-                                    <property name="receives_default">True</property>
-                                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                                    <property name="has_tooltip">True</property>
-                                    <property name="tooltip_markup" translatable="yes">View and edit keyboard layout options</property>
-                                    <property name="tooltip_text" translatable="yes">View and edit keyboard layout options</property>
-                                    <property name="use_underline">True</property>
-                                  </object>
-                                  <packing>
-                                    <property name="expand">False</property>
-                                    <property name="fill">False</property>
-                                    <property name="position">0</property>
-                                  </packing>
-                                </child>
-                                <child>
-                                  <object class="GtkButton" id="xkb_reset_to_defaults">
-                                    <property name="label" translatable="yes">Reset to De_faults</property>
-                                    <property name="visible">True</property>
-                                    <property name="can_focus">True</property>
-                                    <property name="receives_default">True</property>
-                                    <property name="has_tooltip">True</property>
-                                    <property name="tooltip_markup" translatable="yes">Replace the current keyboard layout settings with the
-default settings</property>
-                                    <property name="tooltip_text" translatable="yes">Replace the current keyboard layout settings with the
-default settings</property>
-                                    <property name="use_underline">True</property>
-                                  </object>
-                                  <packing>
-                                    <property name="expand">False</property>
-                                    <property name="fill">False</property>
-                                    <property name="pack_type">end</property>
-                                    <property name="position">1</property>
-                                    <property name="secondary">True</property>
-                                  </packing>
-                                </child>
+                                <property name="label" translatable="yes">Shortcuts</property>
+                                <property name="use_markup">True</property>
+                                <attributes>
+                                  <attribute name="weight" value="bold"/>
+                                </attributes>
                               </object>
-                              <packing>
-                                <property name="expand">False</property>
-                                <property name="fill">False</property>
-                                <property name="position">2</property>
-                              </packing>
                             </child>
                           </object>
                           <packing>
@@ -951,17 +984,17 @@ default settings</property>
                     </child>
                   </object>
                   <packing>
-                    <property name="position">2</property>
+                    <property name="position">3</property>
                   </packing>
                 </child>
                 <child type="tab">
-                  <object class="GtkLabel" id="label46">
+                  <object class="GtkLabel" id="label13">
                     <property name="visible">True</property>
                     <property name="can_focus">False</property>
-                    <property name="label" translatable="yes">Keyboard Layouts</property>
+                    <property name="label" translatable="yes">Input Sources</property>
                   </object>
                   <packing>
-                    <property name="position">2</property>
+                    <property name="position">3</property>
                     <property name="tab_fill">False</property>
                   </packing>
                 </child>
@@ -974,9 +1007,6 @@ default settings</property>
                     <property name="column_spacing">12</property>
                     <property name="row_spacing">12</property>
                     <child>
-                      <placeholder/>
-                    </child>
-                    <child>
                       <object class="GtkLabel" id="system-title">
                         <property name="visible">True</property>
                         <property name="can_focus">False</property>
@@ -1051,6 +1081,7 @@ default settings</property>
                                 <property name="bottom_attach">2</property>
                                 <property name="x_padding">3</property>
                                 <property name="y_padding">3</property>
+                                <property name="y_options">GTK_FILL</property>
                               </packing>
                             </child>
                             <child>
@@ -1060,6 +1091,7 @@ default settings</property>
                                 <property name="xalign">0</property>
                                 <property name="yalign">0</property>
                                 <property name="wrap">True</property>
+                                <property name="width-chars">18</property>
                               </object>
                               <packing>
                                 <property name="left_attach">1</property>
@@ -1068,6 +1100,7 @@ default settings</property>
                                 <property name="bottom_attach">2</property>
                                 <property name="x_padding">3</property>
                                 <property name="y_padding">3</property>
+                                <property name="y_options">GTK_FILL</property>
                               </packing>
                             </child>
                             <child>
@@ -1178,6 +1211,7 @@ default settings</property>
                                 <property name="bottom_attach">2</property>
                                 <property name="x_padding">3</property>
                                 <property name="y_padding">3</property>
+                                <property name="y_options">GTK_FILL</property>
                               </packing>
                             </child>
                             <child>
@@ -1187,6 +1221,7 @@ default settings</property>
                                 <property name="xalign">0</property>
                                 <property name="yalign">0</property>
                                 <property name="wrap">True</property>
+                                <property name="width-chars">18</property>
                               </object>
                               <packing>
                                 <property name="left_attach">1</property>
@@ -1195,6 +1230,7 @@ default settings</property>
                                 <property name="bottom_attach">2</property>
                                 <property name="x_padding">3</property>
                                 <property name="y_padding">3</property>
+                                <property name="y_options">GTK_FILL</property>
                               </packing>
                             </child>
                             <child>
@@ -1254,6 +1290,7 @@ default settings</property>
                     <child>
                       <object class="GtkButton" id="copy_settings_button">
                         <property name="label" translatable="yes">Copy Settings...</property>
+                        <property name="use_action_appearance">False</property>
                         <property name="visible">True</property>
                         <property name="can_focus">True</property>
                         <property name="receives_default">True</property>
@@ -1269,9 +1306,12 @@ default settings</property>
                         <property name="y_padding">3</property>
                       </packing>
                     </child>
+                    <child>
+                      <placeholder/>
+                    </child>
                   </object>
                   <packing>
-                    <property name="position">3</property>
+                    <property name="position">4</property>
                   </packing>
                 </child>
                 <child type="tab">
@@ -1281,7 +1321,7 @@ default settings</property>
                     <property name="label" translatable="yes">System</property>
                   </object>
                   <packing>
-                    <property name="position">3</property>
+                    <property name="position">4</property>
                     <property name="tab_fill">False</property>
                   </packing>
                 </child>
@@ -1302,4 +1342,11 @@ default settings</property>
       </object>
     </child>
   </object>
+  <object class="GtkSizeGroup" id="system-input-source-sizegroup">
+    <property name="mode">vertical</property>
+    <widgets>
+      <widget name="user_input_source"/>
+      <widget name="system_input_source"/>
+    </widgets>
+  </object>
 </interface>
diff -uNrp a/panels/region/.indent.pro b/panels/region/.indent.pro
--- a/panels/region/.indent.pro	1970-01-01 01:00:00.000000000 +0100
+++ b/panels/region/.indent.pro	2013-08-25 16:50:30.000000000 +0100
@@ -0,0 +1,2 @@
+-kr -i8 -pcs -lps -psl
+
diff -uNrp a/panels/region/Makefile.am b/panels/region/Makefile.am
--- a/panels/region/Makefile.am	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/Makefile.am	2013-09-21 13:24:15.347949247 +0100
@@ -23,12 +23,9 @@ libregion_la_SOURCES =	\
 	cinnamon-region-panel-lang.h \
 	cinnamon-region-panel-system.c \
 	cinnamon-region-panel-system.h \
-	cinnamon-region-panel-xkb.c \
-	cinnamon-region-panel-xkblt.c \
-	cinnamon-region-panel-xkbltadd.c \
-	cinnamon-region-panel-xkbot.c \
-	cinnamon-region-panel-xkbpv.c \
-	cinnamon-region-panel-xkb.h
+	cinnamon-region-panel-input.c \
+	cinnamon-region-panel-input.h \
+	$(NULL)
 
 libregion_la_LIBADD = $(PANEL_LIBS) $(REGION_PANEL_LIBS) $(builddir)/../common/liblanguage.la
 
@@ -39,8 +36,8 @@ libregion_la_LDFLAGS = $(PANEL_LDFLAGS)
 uidir   = $(pkgdatadir)/ui
 ui_DATA = \
 	cinnamon-region-panel.ui \
-	cinnamon-region-panel-layout-chooser.ui \
-	cinnamon-region-panel-options-dialog.ui
+	cinnamon-region-panel-input-chooser.ui \
+	$(NULL)
 
 desktopdir = $(datadir)/applications
 Desktop_in_files = cinnamon-region-panel.desktop.in
